diff --git a/ChangeLog.d/getrandom.txt b/ChangeLog.d/getrandom.txt
new file mode 100644
index 00000000000..7e284415c71
--- /dev/null
+++ b/ChangeLog.d/getrandom.txt
@@ -0,0 +1,2 @@
+Changes
+   Use glibc's getrandom() instead of syscall when glibc > 2.15.
diff --git a/library/entropy_poll.c b/library/entropy_poll.c
index 4bf660e055a..bab315a61d1 100644
--- a/library/entropy_poll.c
+++ b/library/entropy_poll.c
@@ -18,9 +18,15 @@
  */
 
 #if defined(__linux__)
+#if !defined(_GNU_SOURCE)
 /* Ensure that syscall() is available even when compiling with -std=c99 */
 #define _GNU_SOURCE
 #endif
+#include <features.h>
+#if __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 25
+#define HAVE_SYS_RANDOM 1
+#endif
+#endif
 
 #include "common.h"
 
@@ -86,10 +92,15 @@ int mbedtls_platform_entropy_poll( void *data, unsigned char *output, size_t len
 
 /*
  * Test for Linux getrandom() support.
- * Since there is no wrapper in the libc yet, use the generic syscall wrapper
+ * When glibc > 2.25 include sys/random.h for getrandom(),
+ * else use the generic syscall wrapper
  * available in GNU libc and compatible libc's (eg uClibc).
  */
-#if ((defined(__linux__) && defined(__GLIBC__)) || defined(__midipix__))
+#if HAVE_SYS_RANDOM
+#include <sys/random.h>
+#include <errno.h>
+#define HAVE_GETRANDOM
+#elif defined(__linux__) || defined(__midipix__)
 #include <unistd.h>
 #include <sys/syscall.h>
 #if defined(SYS_getrandom)
@@ -155,7 +166,11 @@ int mbedtls_platform_entropy_poll( void *data,
     ((void) data);
 
 #if defined(HAVE_GETRANDOM)
+#if HAVE_SYS_RANDOM
+    ret = getrandom(output, len, 0);
+#else
     ret = getrandom_wrapper( output, len, 0 );
+#endif
     if( ret >= 0 )
     {
         *olen = ret;
